/** ***************************************************************************
 * @file  File.h
 * @brief FileNX̐錾
 * @author Hidekazu Ito
 * @date 2015/05/09
 ******************************************************************************/

#pragma once
#ifndef File_h__
#define File_h__

#include <windows.h>

#define USE_WINDOWS_SHELL    ///< Windows Shellpꍇ͒`

/** *****************************************************************
 * @namespace Win32Utility
 * @brief Win32APĨ[eBeBO
 ********************************************************************/
namespace Win32Utility
{
    /** *****************************************************************
     * @class File
     * @brief t@CNX
     ********************************************************************/
    class File
    {
    public:
        /** *****************************************************************
         * @brief RXgN^
         ********************************************************************/
        File();

        /** *****************************************************************
         * @brief fXgN^
         ********************************************************************/
        virtual ~File();

        /** *****************************************************************
         * @brief t@Ci̎擾j
         * @param[in]  filePath  t@C(pX)BChJ[h(*,?Ȃ)gp\
         * @return  Ԃ
         ********************************************************************/
        DWORD SearchFile(LPCTSTR filePath);

        /** *****************************************************************
         * @brief t@Cĩt@C擾j
         * @param[out]  fileName   t@C̊i[
         * @param[in]   maxLength  i[̃̕TCY(oCg)
         * @retval  FALSE  s
         * @retval  TRUE   
         ********************************************************************/
        BOOL GetNextSearchedFile(LPTSTR fileName, DWORD maxLength);

        /** *****************************************************************
         * @brief ut@CJv_CAO̕\
         * @param[out]  filePath   t@C(pX)̊i[
         * @param[in]   maxLength  i[敶̃TCY()
         * @param[in]   filter     tB^
         * @retval  FALSE  s
         * @retval  TRUE   
         ********************************************************************/
        static BOOL GetOpenFile(LPTSTR filePath, DWORD maxLength, LPCTSTR filter=TEXT("ׂẴt@C(*.*)\0*.*\0\0"));

        /** *****************************************************************
         * @brief uOtĕۑv_CAO̕\
         * @param[out]  filePath  t@C(pX)̊i[
         * @param[in]   maxLength  i[敶̃TCY()
         * @param[in]   filter    tB^
         * @retval  FALSE  s
         * @retval  TRUE   
         ********************************************************************/
        static BOOL GetSaveFile(LPTSTR filePath, DWORD maxLength, LPCTSTR filter=TEXT("ׂẴt@C(*.*)\0*.*\0\0"));

        /** *****************************************************************
         * @brief st@C̎擾
         * @param[out]  filePath   t@C(pX)̊i[
         * @param[in]   maxLength  i[敶̃TCY()
         * @retval  FALSE  s
         * @retval  TRUE   
         ********************************************************************/
        static BOOL GetExeFile(LPTSTR filePath, DWORD maxLength);

        /** *****************************************************************
         * @brief stH_̎擾
         * @param[out]  filePath   t@C(pX)̊i[
         * @param[in]   maxLength  i[敶̃TCY()
         * @retval  FALSE  s
         * @retval  TRUE   
         ********************************************************************/
        static BOOL GetExeFolder(LPTSTR filePath, DWORD maxLength);

#ifdef USE_WINDOWS_SHELL
        /** *****************************************************************
         * @brief tH_I_CAO̕\
         * @param[out]  filePath  tH_(pX)̊i[
         * @retval  FALSE  s
         * @retval  TRUE   
         ********************************************************************/
        BOOL GetFolder(TCHAR filePath[MAX_PATH]);

        /** *****************************************************************
         * @brief t@C̎擾
         * @param[in]   filePath     t@C(pX)
         * @param[out]  typeName     t@C`̊̕i[
         * @param[out]  displayName  \t@C̊i[
         * @retval  FALSE  s
         * @retval  TRUE   
         ********************************************************************/
        BOOL GetFileInfo(LPCTSTR filePath, TCHAR typeName[80], TCHAR displayName[MAX_PATH]);

        /** *****************************************************************
         * @brief t@C̍폜
         * @param[in]  filePath      t@C(pX)
         * @param[in]  toRecycleBin  S~Ɉړ邩w(TRUE=S~)
         * @retval  FALSE  s
         * @retval  TRUE   
         ********************************************************************/
        BOOL DeleteFile(LPCTSTR filePath, BOOL toRecycleBin);

        /** *****************************************************************
         * @brief t@C̖OύX
         * @param[in]  fileName     t@C(pX)
         * @param[in]  newFileName  Vt@C(pX)
         * @retval  FALSE  s
         * @retval  TRUE   
         ********************************************************************/
        BOOL RenameFile(LPCTSTR fileName, LPCTSTR newFileName);

        /** *****************************************************************
         * @brief t@C̃Rs[
         * @param[in]  filePath     Rs[̃t@C(pX)
         * @param[in]  newFilePath  Rs[̃t@C(pX)
         * @retval  FALSE  s
         * @retval  TRUE   
         ********************************************************************/
        BOOL CopyFile(LPCTSTR filePath, LPCTSTR newFilePath);

        /** *****************************************************************
         * @brief t@C̈ړ
         * @param[in]  filePath     ړ̃t@C(pX)
         * @param[in]  newFilePath  ړ̃t@C(pX)
         * @retval  FALSE  s
         * @retval  TRUE   
         ********************************************************************/
        BOOL MoveFile(LPCTSTR filePath, LPCTSTR newFilePath);

#endif

    private:
        HANDLE m_hFind;         ///< t@Cnh
        WIN32_FIND_DATA m_FD;   ///< t@Cʂ̊i[
    };
}

#endif // File_h__

// EOF